<?php
/**
 * Installer config
 * @copyright   CONTREXX CMS - COMVATION AG
 * @author        Comvation Development Team <info@comvation.com>
 * @version       1.0.0
 * @package     contrexx
 * @subpackage  core
 * @todo        Edit PHP DocBlocks!
 */

$requiredPHPVersion = "4.3";
$requiredMySQLVersion = "4.0";
$requiredGDVersion = "1.6";
$dbType = "mysql";
$defaultLanguage = "de";
$licenseFileCommerce = "data".DIRECTORY_SEPARATOR."contrexx_lizenz_de.txt";
$licenseFileOpenSource = "data".DIRECTORY_SEPARATOR."contrexx_lizenz_opensource_de.txt";
$configFile = "/config/configuration.php";
$configTemplateFile = "data".DIRECTORY_SEPARATOR."configuration.tpl";
$versionFile = "/config/version.php";
$versionTemplateFile = "data".DIRECTORY_SEPARATOR."version.tpl";
$sqlDumpFile = DIRECTORY_SEPARATOR."installer".DIRECTORY_SEPARATOR."data".DIRECTORY_SEPARATOR."contrexx_dump";
$dbPrefix = "contrexx_";
$templatePath = "template/contrexx/";
$supportEmail = "support@contrexx.com";
$supportURI = "http://www.contrexx.com/index.php?page=754";
$forumURI = "http://www.contrexx.com/forum/";
$contrexxURI = "http://www.contrexx.com/";
$useUtf8 = true;

$_CONFIG['coreCmsName']	     	= 'Contrexx® Web Content Management System';
$_CONFIG['coreCmsVersion']	  	= '1.2.3';
$_CONFIG['coreCmsStatus']	  	= 'Stable';
$_CONFIG['coreCmsEdition']		= 'OpenSource';
$_CONFIG['coreCmsCodeName']	  	= 'Cow Feeder';
$_CONFIG['coreCmsReleaseDate'] 	= '21.04.2008';

$arrDefaultConfig = array(
	'dbHostname'	=> 'localhost',
	'dbUsername'	=> '',
	'dbPassword'	=> '',
	'dbDatabaseName'	=> '',
	'dbTablePrefix'	=> 'contrexx_',
	'ftpHostname'	=> 'localhost',
	'ftpUsername'	=> '',
	'ftpPassword'	=> ''
);

$arrLanguages = array(
	1	=> array(
		'id'	=> 1,
		'lang'	=> 'de',
		'name'	=> 'Deutsch',
		'is_default'	=> true
	),
	2	=> array(
		'id'	=> 2,
		'lang'	=> 'en',
		'name'	=> 'English',
		'is_default'	=> false
	)
);

$arrFiles = array(
	'/cadmin/backup' => array(
		'mode'		=> '0777',
		'mode_oct'	=> 0777
	),
	'/config'		=> array(
		'mode'		=> '0777',
		'mode_oct'	=> 0777
	),
	'/feed'	=> array(
		'mode'		=> '0777',
		'mode_oct'	=> 0777,
		'sub_dirs'	=> true
	),
	'/media'	=> array(
		'mode'		=> '0777',
		'mode_oct'	=> 0777,
		'sub_dirs'	=> true
	),
	'/images'	=> array(
		'mode'		=> '0777',
		'mode_oct'	=> 0777,
		'sub_dirs'	=> true
	),
	'/themes'	=> array(
		'mode'		=> '0777',
		'mode_oct'	=> 0777,
		'sub_dirs'	=> true
	),
	'/tmp'		=> array(
		'mode'		=> '0777',
		'mode_oct'	=> 0777,
		'sub_dirs'	=> true
	),
	'/cache'	=> array(
		'mode'		=> '0777',
		'mode_oct'	=> 0777
	),
	'/sitemap.xml'	=> array(
		'mode'		=> '0777',
		'mode_oct'	=> 0777
	)
);

$arrDatabaseTables = array(
	'module_alias_source',
	'module_alias_target',
	'module_block_blocks',
	'module_block_rel_lang',
	'module_block_rel_pages',
	'module_block_settings',
	'module_blog_categories',
	'module_blog_comments',
	'module_blog_messages',
	'module_blog_messages_lang',
	'module_blog_message_to_category',
	'module_blog_networks',
	'module_blog_networks_lang',
	'module_blog_settings',
	'module_blog_votes',
	'module_calendar',
	'module_calendar_access',
	'module_calendar_categories',
	'module_calendar_form_data',
	'module_calendar_form_fields',
	'module_calendar_registrations',
	'module_calendar_settings',
	'module_calendar_style',
	'community_config',
	'module_contact_form',
	'module_contact_form_data',
	'module_contact_form_field',
	'module_contact_settings',
	'access_group_dynamic_ids',
	'access_group_static_ids',
	'access_users',
	'access_user_groups',
	'backend_areas',
	'backups',
	'content',
	'content_history',
	'content_logfile',
	'content_navigation',
	'content_navigation_history',
	'ids',
	'languages',
	'log',
	'modules',
	'module_repository',
	'sessions',
	'settings',
	'settings_smtp',
	'skins',
	'module_directory_access',
	'module_directory_categories',
	'module_directory_dir',
	'module_directory_inputfields',
	'module_directory_levels',
	'module_directory_mail',
	'module_directory_rel_dir_cat',
	'module_directory_rel_dir_level',
	'module_directory_settings',
	'module_directory_settings_google',
	'module_directory_vote',
	'module_docsys',
	'module_docsys_categories',
	'module_feed_category',
	'module_feed_news',
	'module_feed_newsml_association',
	'module_feed_newsml_categories',
	'module_feed_newsml_documents',
	'module_feed_newsml_providers',
	'module_forum_access',
	'module_forum_categories',
	'module_forum_categories_lang',
	'module_forum_notification',
	'module_forum_postings',
	'module_forum_settings',
	'module_forum_statistics',
	'module_gallery_categories',
	'module_gallery_comments',
	'module_gallery_language',
	'module_gallery_language_pics',
	'module_gallery_pictures',
	'module_gallery_settings',
	'module_gallery_votes',
	'module_guestbook',
	'module_guestbook_settings',
	'module_news',
	'module_news_access',
	'module_news_categories',
	'module_news_settings',
	'module_news_teaser_frame',
	'module_news_teaser_frame_templates',
	'module_news_ticker',
	'module_newsletter',
	'module_newsletter_attachment',
	'module_newsletter_category',
	'module_newsletter_confirm_mail',
	'module_newsletter_rel_cat_news',
	'module_newsletter_rel_user_cat',
	'module_newsletter_settings',
	'module_newsletter_template',
	'module_newsletter_tmp_sending',
	'module_newsletter_user',
	'module_newsletter_user_title',
	'module_podcast_category',
	'module_podcast_medium',
	'module_podcast_rel_category_lang',
	'module_podcast_rel_medium_category',
	'module_podcast_settings',
	'module_podcast_template',
	'module_recommend',
	'stats_browser',
	'stats_colourdepth',
	'stats_config',
	'stats_country',
	'stats_hostname',
	'stats_javascript',
	'stats_operatingsystem',
	'stats_referer',
	'stats_requests',
	'stats_requests_summary',
	'stats_screenresolution',
	'stats_search',
	'stats_spiders',
	'stats_spiders_summary',
	'stats_visitors',
	'stats_visitors_summary',
	'voting_email',
	'voting_rel_email_system',
	'voting_results',
	'voting_system'
);
?>
